function query=AURO(data, GroundTruth, init_data, init_GroundTruth)
% data: n*d, one row for an instance with d features
% GroundTruth: n*n_class, one row for an instance, -1 means irrelevant, a positive value means relevant, the larger, the more relevant
% init_data: a small set of fully labeled data

targets=zeros(size(GroundTruth));
targets=[targets,2*ones(size(targets,1),1)];
init_GroundTruth=[init_GroundTruth,2*ones(size(init_GroundTruth,1),1)];
        
% initialization
[B,V,AB,AV,Anum,trounds,costs,norm_up,step_size0,num_sub,lambda,average_begin,average_size,n_repeat,max_query]=AURO_Init(init_data, init_GroundTruth);

BV=(AV/Anum)'*(AB/Anum);
[pres,labels]=AURO_predict(BV,data,num_sub);

n_batch=size(targets,2);
query=[];%zeros(n_query,4);

idxPs=[];
idxNs=[];
idxIns=[];

t=0;
while(true)
    t=t+1;
    % selection
    [idx_Ins, idx_L1, idx_L2, type_Ans]=AURO_select(pres,labels, targets, GroundTruth);
        
    if(isempty(idx_Ins)||t>max_query)
        break;
    end
    query=[query;[idx_Ins, idx_L1, idx_L2, type_Ans]];
    
    % update the model
    idxLP=0;
    idxLN=0;
    if(type_Ans==1) % L1>L2
        idxLP=idx_L1;
        idxLN=idx_L2;
        targets(idx_Ins,idx_L1)=1;
        targets(idx_Ins,idx_L2)=0.5;
    elseif(type_Ans==2) % L1<L2
        idxLP=idx_L2;
        idxLN=idx_L1;
        targets(idx_Ins,idx_L1)=0.5;
        targets(idx_Ins,idx_L2)=1;
    elseif(type_Ans==3) % both irrelevant
        targets(idx_Ins,idx_L1)=-1;
        targets(idx_Ins,idx_L2)=-1;
    end
    idxIns=[idxIns,idx_Ins];
    idxPs=[idxPs,idxLP];
    idxNs=[idxNs,idxLN];
    if(mod(t,n_batch)==0)
        for tt=1:n_repeat
            [B,V,AB,AV,Anum,trounds]=AURO_train(data(idxIns,:),targets(idxIns,:),B,V,idxPs,idxNs,costs,norm_up,step_size0,num_sub,AB,AV,Anum,trounds,lambda,average_begin,average_size);
        end
        BV=(AV/Anum)'*(AB/Anum);
        [pres,labels]=AURO_predict(BV,data,num_sub);
        
        idxPs=[];
        idxNs=[];
        idxIns=[];
    end
end
end