function [B,V,AB,AV,Anum,trounds,costs,norm_up,step_size0,num_sub,lambda,avg_begin,avg_size,n_repeat,max_query]=AURO_Init(init_data, init_targets)
% initialize the classification model

d=size(init_data,2);
n_class=size(init_targets,2);
n_repeat=10;
max_query=floor(size(init_targets,1)*(size(init_targets,2)-1)/2);
D=200;
num_sub=5;
norm_up=inf;
lambda=0;%.0000001;
step_size0=0.05;
avg_begin=10;
avg_size=5;

costs=1./(1:n_class*5);
for k=2:n_class*5
    costs(k)=costs(k-1)+costs(k);
end

V=normrnd(0,1/sqrt(d),D,d); % D*m
B=normrnd(0,1/sqrt(d),D,n_class*num_sub); % D*n_class
for k=1:d
    tmp1=V(:,k);
    if(tmp1>norm_up)
        V(:,k)=tmp1*norm_up/norm(tmp1);
    end
end
for k=1:n_class*num_sub
    tmp1=B(:,k);
    if(tmp1>norm_up)
        B(:,k)=tmp1*norm_up/norm(tmp1);
    end
end

AB=0;
AV=0;
Anum=0;
trounds=0;

for rr=1:n_repeat
    [B,V,AB,AV,Anum,trounds]=AURO_train(init_data,init_targets,B,V,zeros(1,size(init_targets,1)),zeros(1,size(init_targets,1)),costs,norm_up,step_size0,num_sub,AB,AV,Anum,trounds,lambda,avg_begin,avg_size);
end