function [idx_Ins, idx_L1, idx_L2, type_Ans]=AURO_select(pres,labels, targets, GroundTruth)
%select one most positive and least negative label from unlabeled labels

% select the least queried instance
n_unquery=sum(targets==0|targets==0.5,2);
idx_Ins=find(n_unquery==max(n_unquery));
idx_Ins=idx_Ins(randi(length(idx_Ins)));
if(n_unquery(idx_Ins)==0)
    idx_Ins=[];
    idx_L1=[];
    idx_L2=[];
    type_Ans=[];
    return;
elseif(n_unquery(idx_Ins)==1)
    one_target=targets(idx_Ins,:);
    one_pre=pres(idx_Ins,:);
    idx_L1=find(one_target==0|one_target==0.5);
    idx_L2=find(one_target==-1);
    
    [tmp,idxmax]=max(one_pre(idx_L2));
    idx_L2=idx_L2(idxmax);
else
    one_target=targets(idx_Ins,:);
    one_pre=pres(idx_Ins,:);
    one_label=labels(idx_Ins,:);
    idx_L=find(one_target==0|one_target==0.5);
    [tmp,idxmax]=max(one_pre(idx_L));
    idx_L1=idx_L(idxmax);
    idx_L(idxmax)=[];
    if(sum(one_label(idx_L)==-1)>0)
        one_pre(one_label==1)=-inf;
        [tmp,idxmax]=max(one_pre(idx_L));
    else
        [tmp,idxmax]=min(one_pre(idx_L));
    end
    idx_L2=idx_L(idxmax);
end

GT1=GroundTruth(idx_Ins,idx_L1);
GT2=GroundTruth(idx_Ins,idx_L2);
if(GT1>GT2)
    type_Ans=1;
elseif(GT1<GT2)
    type_Ans=2;
elseif(GT1==-1&&GT2==-1)
    type_Ans=3;
else
    type_Ans=round(rand(1))+1;
end